version 8
log using "/projects/arts110/Productivity_Manufacturing/FHS/ppsr50/revise/weight/wt4/tab3_persist.log", replace

set memory 100m
set matsize 800
set more off

insheet using /projects/arts110/Productivity_Manufacturing/FHS/ppsr50/revise/weight/wt4/alllag.csv, comma,
save /projects/arts110/Productivity_Manufacturing/FHS/ppsr50/revise/weight/wt4/tab3_persist, replace 



label variable ltfp "LTFP persist"
xi: reg ltfp i.year*i.prod lltfp, cluster(ppn)

label variable ltfp2 "LTFP2 persist"
xi: reg ltfp2 i.year*i.prod lltfp2, cluster(ppn)

label variable ltfpphy "LTFPPHY persist"
xi: reg ltfpphy i.year*i.prod lltfpphy, cluster(ppn)

label variable lprice2 "LPRICE2 persist"
xi: reg lprice2 i.year*i.prod llprice2, cluster(ppn)

label variable dshk99 "DSHK persist"
xi: reg dshk99 i.year*i.prod ldshk99, cluster(ppn)



* now weighted

label variable ltfp "LTFP persist"
xi: reg ltfp i.year*i.prod lltfp [aweight=rnq2], cluster(ppn)

label variable ltfp2 "LTFP2 persist"
xi: reg ltfp2 i.year*i.prod lltfp2 [aweight=rnq2], cluster(ppn)

label variable ltfpphy "LTFPPHY persist"
xi: reg ltfpphy i.year*i.prod lltfpphy [aweight=rnq2], cluster(ppn)

label variable lprice2 "LPRICE2 persist"
xi: reg lprice2 i.year*i.prod llprice2 [aweight=rnq2], cluster(ppn)

label variable dshk99 "LPRICE2 persist"
xi: reg dshk99 i.year*i.prod ldshk99 [aweight=rnq2], cluster(ppn)

 

log close
