version 8
log using "/projects/arts110/Productivity_Manufacturing/FHS/ppsr50/revise/weight/wt4/local6/prices_all_k_cluster.log", replace

set memory 100m
set matsize 800
set more off

insheet using /projects/arts110/Productivity_Manufacturing/FHS/ppsr50/revise/weight/wt4/local6/allwt.csv, comma,
save /projects/arts110/Productivity_Manufacturing/FHS/ppsr50/revise/weight/wt4/local6/prices_all_k_cluster, replace 


label variable fdeath "LTFP only"
xi: dprobit fdeath i.year*i.prod ltfp, cluster(ppn) 
label variable fdeath "LTFP2 only"
xi: dprobit fdeath i.year*i.prod ltfp2, cluster(ppn)
label variable fdeath "LTFPPHY only"
xi: dprobit fdeath i.year*i.prod ltfpphy, cluster(ppn) 
label variable fdeath "Lprice2 only"
xi: dprobit fdeath i.year*i.prod lprice2, cluster(ppn)
label variable fdeath "dshk99 only"
xi: dprobit fdeath i.year*i.prod dshk99, cluster(ppn)
label variable fdeath "LTPPHY and LPRICE2"
xi: dprobit fdeath i.year*i.prod ltfpphy lprice2, cluster(ppn) 
label variable fdeath "LTPPHY and dshk99"
xi: dprobit fdeath i.year*i.prod ltfpphy dshk99, cluster(ppn) 

* now control for capital
label variable fdeath "LTFP & K only"
xi: dprobit fdeath i.year*i.prod ltfp lk, cluster(ppn)
label variable fdeath "LTFP2 & K only"
xi: dprobit fdeath i.year*i.prod ltfp2 lk, cluster(ppn)
label variable fdeath "LTFPPHY & K only"
xi: dprobit fdeath i.year*i.prod ltfpphy lk, cluster(ppn)
label variable fdeath "Lprice2 & K only"
xi: dprobit fdeath i.year*i.prod lprice2 lk, cluster(ppn)
label variable fdeath "dshk99 & K only"
xi: dprobit fdeath i.year*i.prod dshk99 lk, cluster(ppn)
label variable fdeath "LTPPHY and LPRICE2 & K"
xi: dprobit fdeath i.year*i.prod ltfpphy lprice2 lk, cluster(ppn) 
label variable fdeath "LTPPHY and dshk99 &K "
xi: dprobit fdeath i.year*i.prod ltfpphy dshk99 lk, cluster(ppn)


log close
