* Table9b_aer.sas;

options linesize=72;run;
libname prod '/projects/arts110/Productivity_Manufacturing/FHS/ppsr50/revise/weight/wt4/ppsr90';

*options obs=5000;run;
options ls=72;


%macro chk(d);
       * d= product name;
       


  data all;
    set prod.all&d;
    rnq2=nq2/piship;run;
 
  proc sort data=all;by ppn year;run;

  proc summary data=all nway;
    class year;
    var fdeath fbirth lbirth ldeath;
    output out=bd mean=;

  data all;
    set all;
    if phyq>0;

  * need to be careful here on averages to use correct group;

  %macro five(b,e);

    data allf(keep=ppn);
      set all;
      if year=19&e or year=19&b;


    proc sort data=allf nodupkey;by ppn;run;
    proc sort data=all;by ppn;run;  

    data allf;
      merge all allf(in=five);by ppn;if five=1;
      if year=19&b or year=19&e; 
      if  (year=19&e and (lcont=1 or lbirth=1))
       or (year=19&b and (fdeath=1 or fcont=1));*added this back;
				   * want to make sure have bcd cases;

    * now do decomposition;




   data allf&b(keep=ppn rnq2b ltfpb ltfp2b ltfp3b ltfpphyb fdeath fbirth fcont
 lprice2b);
      set allf;
      if year=19&b;
      rnq2b=rnq2;		
      ltfpb=ltfp;
      ltfp2b=ltfp2;
      ltfp3b=ltfp3;
      ltfpphyb=ltfpphy;
      lprice2b=lprice2;

   proc sort;by ppn;

   data allf&e(keep=ppn rnq2e ltfpe ltfp2e ltfp3e ltfpphye ldeath lbirth lcont
 lprice2e);
     set allf;
     if year=19&e;
     rnq2e=rnq2;		
     ltfpe=ltfp;
     ltfp2e=ltfp2;
     ltfp3e=ltfp3;
     ltfpphye=ltfpphy;
      lprice2e=lprice2;

  proc sort;by ppn;

  data allf;
    merge allf&b allf&e;by ppn;
    mer=1;
    * dont think this is as critical but keeping;
    * want to make sure businesses have productivity measure;
    if lcont=1 and (rnq2e=. or rnq2b=. or ltfp2b=. or ltfp2e=. or ltfpphye=. or ltfpphyb=.) then delete;
    if fcont=1 and (rnq2e=. or rnq2b=. or ltfp2b=. or ltfp2e=. or ltfpphye=. or ltfpphyb=.) then delete;
    if fdeath=1 and (rnq2b=. or ltfp2b=. or ltfpphyb=.) then delete;
    if lbirth=1 and (rnq2e=. or ltfp2e=. or ltfpphye=.) then delete;
    if lcont=1 and fcont^=1 then delete;
    if fcont=1 and lcont^=1 then delete; 


  proc summary data=allf;
    by mer;  
    weight rnq2b;
    var ltfpb;
    output out=mltfpb mean=mltfpb;

  proc summary data=allf;
    by mer;  
    weight rnq2b;
    var ltfp2b;
    output out=mltfp2b mean=mltfp2b;

  proc summary data=allf;
    by mer;  
    weight rnq2b;
    var ltfp3b;
    output out=mltfp3b mean=mltfp3b;

  proc summary data=allf;
    by mer;  
    weight rnq2b;
    var ltfpphyb;
    output out=mltfppb mean=mltfppb;

  proc summary data=allf;
    by mer;  
    weight rnq2e;
    var ltfpe;
    output out=mltfpe mean=mltfpe;

  proc summary data=allf;
    by mer;  
    weight rnq2e;
    var ltfp2e;
    output out=mltfp2e mean=mltfp2e;

  proc summary data=allf;
    by mer;  
    weight rnq2e;
    var ltfp3e;
    output out=mltfp3e mean=mltfp3e;

  proc summary data=allf;
    by mer;  
    weight rnq2e;
    var ltfpphye;
    output out=mltfppe mean=mltfppe;

  proc summary data=allf;
    by mer;
    var rnq2b rnq2e;
    output out=tot sum=trnq2b trnq2e; 

  data agg;
    merge mltfpb mltfp2b mltfp3b mltfppb mltfpe mltfppe mltfp2e mltfp3e tot;
    by mer;run;

  data dec;
    merge allf agg;by mer;
    shareb=rnq2b/trnq2b;sharee=rnq2e/trnq2e;

* NOW CHECK prices and generate an internally consistent correction if prices are off;

  * NOW JUST LOOK AT THE LEVELS OF LTFP2 AND LTFPPHY;
   proc summary data=dec;
     by mer;
     weight shareb;
    var ltfp2b;
    output out=chk2b sum=;
*    proc print;

   proc summary data=dec;
     by mer;
     weight shareb;
    var ltfpphyb;
    output out=chkpb sum=;
 *   proc print;

   proc summary data=dec;
     by mer;
     weight shareb;
    var lprice2b;
    output out=chkprb sum=;
 *   proc print;

   proc summary data=dec;
     by mer;
     weight sharee;
    var ltfp2e;
    output out=chk2e sum=;
 *   proc print;

   proc summary data=dec;
     by mer;
     weight sharee;
    var ltfpphye;
    output out=chkpe sum=;
 *   proc print;

   proc summary data=dec;
     by mer;
     weight sharee;
    var lprice2e;
    output out=chkpre sum=;
 *   proc print;
   
   data chkall; 
     merge chk2b chkpb chkprb chk2e chkpe chkpre;
     by mer;
    checkb=ltfpphyb+lprice2b; 
    checke=ltfpphye+lprice2e; 
    diffeb=checke-checkb;
    diffprice=lprice2e-lprice2b;
    difftfpq=ltfpphye-ltfpphyb;
   run;
   title "checkb (e) should= ltfp2b (e) & lprice2b (e) should = norm";run;
   proc print data= chkall;run;

data ic(keep=mer diffprice);
  set chkall;

proc sort data=dec;by mer;

data dec;
  merge dec ic;by mer;
* because pbard may have been computed on plants that are not legitimate bcd cases need to adjust for this decomposition;
  ltfp2e=ltfp2e-diffprice;
  ltfp3e=ltfp3e-diffprice;
* now go compute terms of dec;
    if lcont=1 then do;
       with=shareb*(ltfpe-ltfpb);
       with2=shareb*(ltfp2e-ltfp2b);
       with3=shareb*(ltfp3e-ltfp3b);
       withp=shareb*(ltfpphye-ltfpphyb);
       betw=(sharee-shareb)*(ltfpb-mltfpb);  
       betw2=(sharee-shareb)*(ltfp2b-mltfp2b);  
       betw3=(sharee-shareb)*(ltfp3b-mltfp3b);  
       betwp=(sharee-shareb)*(ltfpphyb-mltfppb); 
       cross=(sharee-shareb)*(ltfpe-ltfpb);  
       cross2=(sharee-shareb)*(ltfp2e-ltfp2b);  
       cross3=(sharee-shareb)*(ltfp3e-ltfp3b);  
       crossp=(sharee-shareb)*(ltfpphye-ltfpphyb);
       cshareb=shareb;csharee=sharee;
    end;
    if fdeath=1 then do;
       deat=shareb*(ltfpb-mltfpb);
       deat2=shareb*(ltfp2b-mltfp2b);
       deat3=shareb*(ltfp3b-mltfp3b);
       deatp=shareb*(ltfpphyb-mltfppb);
       dshareb=shareb;
    end; 
    if lbirth=1 then do;
       birt=sharee*(ltfpe-mltfpb);
       birt2=sharee*(ltfp2e-mltfp2b);
       birt3=sharee*(ltfp3e-mltfp3b);
       birtp=sharee*(ltfpphye-mltfppb);
       bsharee=sharee;
    end; 
    mtotb=shareb*ltfpb;mtote=sharee*ltfpe;
    mtot2b=shareb*ltfp2b;mtot2e=sharee*ltfp2e;
    mtot3b=shareb*ltfp3b;mtot3e=sharee*ltfp3e;
    mtotpb=shareb*ltfpphyb;mtotpe=sharee*ltfpphye;


    data checkobs;
      set dec; 
      if (lcont=1 or fdeath=1 or lbirth=1) then allflag=1;else allflag=0;
      run;
  /*;
   proc freq data=checkobs;table allflag;run;
   proc freq data=checkobs;table lcont fcont ldeath fdeath lbirth fbirth;run;
  */;

  * DECOMP FOR TFP;
    proc summary data=dec;
      var with betw cross birt deat cshareb csharee bsharee dshareb mtotb
    mtote rnq2b rnq2e;
      output out=dectot&d&b&e sum=;

       data dectot&d&b&e;
         set dectot&d&b&e;
         totshb=cshareb+dshareb;
         totshe=csharee+bsharee;

/*;
    title "Decomposition of Revenue Productivity (1) for &b and &e and &d ";run;
    proc print data=dectot&d&b&e;
*/;

    data dectot&d&b&e;
      set dectot&d&b&e;
     length prod $ 8;
      if birt=. then birt=0;
      if deat=. then deat=0;
      tot=with+betw+cross+birt-deat;
      swith=with/tot;
      sbetw=betw/tot;
      scross=cross/tot;
      sbirt=birt/tot;
      sdeat=deat/tot;
      snetent=sbirt-sdeat;
 prod="&d";    

/*;
title "Decomposition of Revenue Productivity (1)  for &b and &e and &d ";run;
    proc print data=dectot&d&b&e;var tot swith sbetw scross sbirt sdeat snetent;
*/;

  * DECOMP FOR TFP2;
    proc summary data=dec;
      var with2 betw2 cross2 birt2 deat2 cshareb csharee bsharee dshareb
    mtot2b mtot2e rnq2b rnq2e;
      output out=dectot2&d&b&e sum=;

	     data dectot2d&b&e;
	       set dectot2&d&b&e;
	       totshb=cshareb+dshareb;
	       totshe=csharee+bsharee;
	       
/*;	       
    title "Decomposition of Revenue Productivity (2) for &b and &e and &d ";run;
    proc print data=dectot2&d&b&e;
*/;

    data dectot2&d&b&e;
      set dectot2&d&b&e;
  length prod $ 8;
      if birt2=. then birt2=0;
      if deat2=. then deat2=0;
      tot2=with2+betw2+cross2+birt2-deat2;
      swith2=with2/tot2;
      sbetw2=betw2/tot2;
      scross2=cross2/tot2;
      sbirt2=birt2/tot2;
      sdeat2=deat2/tot2;
      snetent2=sbirt2-sdeat2;
 prod="&d";

/*;
    title "Decomposition of Revenue Productivity (2) for &b and &e and &d ";run;
    proc print data=dectot2&d&b&e;var tot2 swith2 sbetw2 scross2 sbirt2 sdeat2 snetent2;
*/;

  * DECOMP FOR TFP3;
    proc summary data=dec;
      var with3 betw3 cross3 birt3 deat3 cshareb csharee bsharee dshareb
    mtot3b mtot3e rnq2b rnq2e;
      output out=dectot3&d&b&e sum=;

        data dectot3&d&b&e;
          set dectot3&d&b&e;
          totshb=cshareb+dshareb;
          totshe=csharee+bsharee;

/*;          
       title "Decomposition of Revenue Productivity (3) for &b and &e and &d ";run;
    proc print data=dectot3&d&b&e;
*/;

    data dectot3&d&b&e;
      set dectot3&d&b&e;
  length prod $ 8;
      if birt3=. then birt3=0;
      if deat3=. then deat3=0;
      tot3=with3+betw3+cross3+birt3-deat3;
      swith3=with3/tot3;
      sbetw3=betw3/tot3;
      scross3=cross3/tot3;
      sbirt3=birt3/tot3;
      sdeat3=deat3/tot3;
      snetent3=sbirt3-sdeat3;
 prod= "&d";

/*;
    title "Decomposition of Revenue Productivity (3) for &b and &e and &d ";run;
    proc print data=dectot3&d&b&e;var tot3 swith3 sbetw3 scross3 sbirt3 sdeat3 snetent3;
*/;

  * DECOMP FOR TFPQ;
    proc summary data=dec;
      var withp betwp crossp birtp deatp cshareb csharee bsharee dshareb
    mtotpb mtotpe rnq2b rnq2e;
      output out=dectotp&d&b&e sum=;

        data dectotp&d&b&e;
          set dectotp&d&b&e;
          totshb=cshareb+dshareb;
          totshe=csharee+bsharee;
          

/*;                               
    title "Decomposition of Quantity Productivity for &b and &e and &d ";run;
    proc print data=dectotp&d&b&e;
*/;

    data dectotp&d&b&e;
      set dectotp&d&b&e;
  length prod $ 8;
      if birtp=. then birtp=0;
      if deatp=. then deatp=0;
      totp=withp+betwp+crossp+birtp-deatp;
      swithp=withp/totp;
      sbetwp=betwp/totp;
      scrossp=crossp/totp;
      sbirtp=birtp/totp;
      sdeatp=deatp/totp;
      snetentp=sbirtp-sdeatp;
      prod= "&d";

/*;
proc print;run;

    title "Decomposition of Quantity Productivity for &b and &e and &d ";run;
    proc print data=dectotp&d&b&e;var totp swithp sbetwp scrossp sbirtp sdeatp
    snetentp;
*/;

%mend;
%five(82,87);
%five(87,92);
*%five(92,97);

%mend;

%chk(concf);
%chk(bredf);
%chk(sugf);
%chk(cofff);
%chk(icebf);
%chk(icepf);
%chk(flrf);
%chk(plyf);
%chk(boxf);
%chk(carbonf);
%chk(gasf);

* NOW DO THE AGGREGATE DECOMP;

%macro agg(b,e);

data aggdec;
 set dectotconcf&b&e dectotcofff&b&e dectotbredf&b&e dectotsugf&b&e dectoticebf&b&e dectoticepf&b&e
 dectotflrf&b&e dectotplyf&b&e dectotboxf&b&e dectotcarbonf&b&e dectotgasf&b&e;
 rnq2aavg=(rnq2b+rnq2e)/2; 


*proc print;run;

proc summary data=aggdec;
   var tot with betw cross birt deat swith sbetw scross sbirt sdeat snetent;
  output out=agg mean=;

*title "Aggregate Decomposition for &b and &e -- LTFP -- Unweighted across Industries";run;

data agg&b&e;set agg;
      swith=with/tot;
      sbetw=betw/tot;
      scross=cross/tot;
      sbirt=birt/tot;
      sdeat=deat/tot;
      snetent=sbirt-sdeat;

*proc print data=agg&b&e;run;


proc summary data=aggdec;
  weight rnq2aavg;
  var tot with betw cross birt deat swith sbetw scross sbirt sdeat snetent;
  output out=agg mean=;

*title "Aggregate Decomposition for &b and &e -- LTFP -- Weighted Across Industries";run;

data aggw&b&e;set agg;
      swith=with/tot;
      sbetw=betw/tot;
      scross=cross/tot;
      sbirt=birt/tot;
      sdeat=deat/tot;
      snetent=sbirt-sdeat;

*proc print data=aggw&b&e;run;

data aggdec;
 set dectot2concf&b&e dectot2cofff&b&e dectot2bredf&b&e dectot2sugf&b&e dectot2icebf&b&e dectot2icepf&b&e
 dectot2flrf&b&e dectot2plyf&b&e dectot2boxf&b&e dectot2carbonf&b&e  dectot2gasf&b&e;
 rnq2aavg=(rnq2b+rnq2e)/2; 

*proc print;run;


proc summary data=aggdec;
  var tot2 with2 betw2 cross2 birt2 deat2 swith2 sbetw2 scross2 sbirt2 sdeat2 snetent2;
  output out=agg mean=;

*title "Aggregate Decomposition for &b and &e -- LTFP2 -- Unweighted Across Industries";run;

data agg2&b&e;set agg;
      swith2=with2/tot2;
      sbetw2=betw2/tot2;
      scross2=cross2/tot2;
      sbirt2=birt2/tot2;
      sdeat2=deat2/tot2;
      snetent2=sbirt2-sdeat2;

*proc print data=agg2&b&e;run;

proc summary data=aggdec;
  weight rnq2aavg;
  var tot2 with2 betw2 cross2 birt2 deat2 swith2 sbetw2 scross2 sbirt2 sdeat2 snetent2;
  output out=agg mean=;

*title "Aggregate Decomposition for &b and &e -- LTFP2 -- Weighted Across Industries";run;

data aggw2&b&e;set agg;
      swith2=with2/tot2;
      sbetw2=betw2/tot2;
      scross2=cross2/tot2;
      sbirt2=birt2/tot2;
      sdeat2=deat2/tot2;
      snetent2=sbirt2-sdeat2;

*proc print data=aggw2&b&e;run;

* now do LTFP3;

data aggdec;
 set dectot3concf&b&e dectot3cofff&b&e dectot3bredf&b&e dectot3sugf&b&e dectot3icebf&b&e dectot3icepf&b&e
 dectot3flrf&b&e dectot3plyf&b&e dectot3boxf&b&e dectot3carbonf&b&e  dectot3gasf&b&e;
 rnq2aavg=(rnq2b+rnq2e)/2; 

*proc print;run;


proc summary data=aggdec;
    var tot3 with3 betw3 cross3 birt3 deat3 swith3 sbetw3 scross3 sbirt3 sdeat3 snetent3;
  output out=agg mean=;

*title "Aggregate Decomposition for &b and &e -- LTFP3 -- Unweighted";run;

data agg3&b&e;set agg;
      swith3=with3/tot3;
      sbetw3=betw3/tot3;
      scross3=cross3/tot3;
      sbirt3=birt3/tot3;
      sdeat3=deat3/tot3;
      snetent3=sbirt3-sdeat3;


*proc print data=agg3&b&e;run;

proc summary data=aggdec;
  weight rnq2aavg;
  var tot3 with3 betw3 cross3 birt3 deat3 swith3 sbetw3 scross3 sbirt3 sdeat3 snetent3;
  output out=agg mean=;

*title "Aggregate Decomposition for &b and &e -- LTFP3 -- Weighted";run;

data aggw3&b&e;set agg;
      swith3=with3/tot3;
      sbetw3=betw3/tot3;
      scross3=cross3/tot3;
      sbirt3=birt3/tot3;
      sdeat3=deat3/tot3;
      snetent3=sbirt3-sdeat3;


*proc print data=aggw3&b&e;run;

* now do LTFPPHY;

data aggdec;
 set dectotpconcf&b&e dectotpcofff&b&e dectotpbredf&b&e dectotpsugf&b&e dectotpicebf&b&e dectotpicepf&b&e
 dectotpflrf&b&e dectotpplyf&b&e dectotpboxf&b&e dectotpcarbonf&b&e dectotpgasf&b&e;
 rnq2aavg=(rnq2b+rnq2e)/2; 

*proc print;run;


proc summary data=aggdec;
    var totp withp betwp crossp birtp deatp swithp sbetwp scrossp sbirtp sdeatp snetentp;
  output out=agg mean=;

data aggp&b&e;
  set agg;
  swithp=withp/totp;
  sbetwp=betwp/totp;
  scrossp=crossp/totp;
   sbirtp=birtp/totp;
   sdeatp=deatp/totp;
   snetentp=sbirtp-sdeatp;


*title "Aggregate Decomposition for &b and &e -- LTFPPHY -- Unweighted";run;
*proc print data=aggp&b&e;run;



proc summary data=aggdec;
  weight rnq2aavg;
  var totp withp betwp crossp birtp deatp swithp sbetwp scrossp sbirtp sdeatp snetentp;
  output out=agg mean=;

data aggwp&b&e;
  set agg;
  swithp=withp/totp;
  sbetwp=betwp/totp;
  scrossp=crossp/totp;
   sbirtp=birtp/totp;
   sdeatp=deatp/totp;
   snetentp=sbirtp-sdeatp;


*title "Aggregate Decomposition for &b and &e -- LTFPPHY -- Weighted";run;
*proc print data=aggwp&b&e;run;

%mend;

%agg(82,87);
%agg(87,92);
*%agg(92,97);

%macro avg(d,s);

data &d;
  set &d.8287 &d.8792;
  swith&s=with&s/tot&s;
  sbetw&s=betw&s/tot&s;
  scross&s=cross&s/tot&s;
   sbirt&s=birt&s/tot&s;
   sdeat&s=deat&s/tot&s;
   snetent&s=sbirt&s-sdeat&s;


title "avg decomp for &d";
proc means data=&d;
%mend;

*%avg(agg,);%avg(aggw,);
*%avg(agg2,2);%avg(aggw2,2);
*%avg(agg3,3);*%avg(aggw3,3);
*%avg(aggp,p);%avg(aggwp,p);

/*;

Note:  aggw yields the traditional, aggw2 yields the revenue and aggwp yields the physical
productivity.  The remaining decompositions were exploratory.

*/;



