* TABLEA1_AER.SAS -- summary statistics on the main raw variables;
* by products;


options ls=72;

libname prod '/projects/arts110/Productivity_Manufacturing/FHS/ppsr50';

data all;
  set prod.allbredf   prod.allsugf  prod.allcofff prod.allicebf
      prod.allicepf   prod.allflrf  prod.allplyf  prod.allboxf
      prod.allcarbonf prod.allgasf  prod.allconcf;
  rnq2=nq2/piship; 
run;

proc sort data=all;by prod year;
 
title "Number of OBS";run;
proc summary data=all;
 var lqphy;
 by prod year;
 output out=nums n=;
run;
proc print data=nums;run;


title "REAL Revenue Share";run;
proc summary data=all nway;
 var rnq2;
output out=ttotal sum=trnq2;
run;

proc summary data=all;
 var rnq2;
 class prod;
output out=ptotal sum=;
run;

data ttotal;
 set ttotal;
 mer=1;
run;

data ptotal;
 set ptotal;
 mer=1;
run;

data total;
  merge ttotal ptotal;
  by mer;
  rrevshare=100*(rnq2/trnq2);
run;
proc print data=total;var prod rrevshare;run;

title "Mean Lincome";run;
proc summary data=all mean;
 var lincome;
 by prod;
 output out=mlinc mean=;
run;
proc print data=mlinc;


