version 8
log using "/projects/arts110/Productivity_Manufacturing/FHS/ppsr50/revise/weight/wt4/tab4_5.log", replace

set memory 100m
set matsize 800
set more off

insheet using /projects/arts110/Productivity_Manufacturing/FHS/ppsr50/revise/weight/wt4/tab45.csv, comma,
save /projects/arts110/Productivity_Manufacturing/FHS/ppsr50/revise/weight/wt4/tab4_5, replace 

* tab 4


label variable ltfp "LTFP evol"
xi: reg ltfp i.year*i.prod fdeath cdum1, cluster(ppn)

label variable ltfp2 "LTFP2 evol"
xi: reg ltfp2 i.year*i.prod fdeath cdum1, cluster(ppn)

label variable ltfpphy "LTFPPHY evol"
xi: reg ltfpphy i.year*i.prod fdeath cdum1, cluster(ppn)

label variable lprice2 "LPRICE2 evol"
xi: reg lprice2 i.year*i.prod fdeath cdum1, cluster(ppn)

label variable dshk99 "DSHK99 evol"
xi: reg dshk99 i.year*i.prod fdeath cdum1, cluster(ppn)


* now weighted


label variable ltfp "LTFP evol"
xi: reg ltfp i.year*i.prod fdeath cdum1 [aweight=rnq2], cluster(ppn)

label variable ltfp2 "LTFP2 evol"
xi: reg ltfp2 i.year*i.prod fdeath cdum1 [aweight=rnq2], cluster(ppn)

label variable ltfpphy "LTFPPHY evol"
xi: reg ltfpphy i.year*i.prod fdeath cdum1 [aweight=rnq2], cluster(ppn)

label variable lprice2 "LPRICE2 evol"
xi: reg lprice2 i.year*i.prod fdeath cdum1 [aweight=rnq2], cluster(ppn)

label variable dshk99 "DSHK99 evol"
xi: reg dshk99 i.year*i.prod fdeath cdum1 [aweight=rnq2], cluster(ppn)

* tab 5

label variable ltfp "LTFP vintage"
xi: reg ltfp i.year*i.prod fdeath cdum1 cdum2 cdum3, cluster(ppn)

label variable ltfp2 "LTFP2 vintage"
xi: reg ltfp2 i.year*i.prod fdeath cdum1 cdum2 cdum3, cluster(ppn)

label variable ltfpphy "LTFPPHY vintage"
xi: reg ltfpphy i.year*i.prod fdeath cdum1 cdum2 cdum3, cluster(ppn)

label variable lprice2 "LPRICE2 vintage"
xi: reg lprice2 i.year*i.prod fdeath cdum1 cdum2 cdum3, cluster(ppn)

label variable dshk99 "DSHK99 vintage"
xi: reg dshk99 i.year*i.prod fdeath cdum1 cdum2 cdum3, cluster(ppn)


* now weighted


label variable ltfp "LTFP vintage"
xi: reg ltfp i.year*i.prod fdeath cdum1 cdum2 cdum3 [aweight=rnq2], cluster(ppn)

label variable ltfp2 "LTFP2 vintage"
xi: reg ltfp2 i.year*i.prod fdeath cdum1 cdum2 cdum3 [aweight=rnq2], cluster(ppn)

label variable ltfpphy "LTFPPHY vintage"
xi: reg ltfpphy i.year*i.prod fdeath cdum1 cdum2 cdum3 [aweight=rnq2], cluster(ppn)

label variable lprice2 "LPRICE2 vintage"
xi: reg lprice2 i.year*i.prod fdeath cdum1 cdum2 cdum3 [aweight=rnq2], cluster(ppn)

label variable dshk99 "DSHK99 vintage"
xi: reg dshk99 i.year*i.prod fdeath cdum1 cdum2 cdum3 [aweight=rnq2], cluster(ppn)


log close
